import { Field, ObjectType } from '@nestjs/graphql';
import { PipelineUnits } from '../enums/pipeline-units.enum';
import { TaskStatuses } from '../enums/task-statuses.enum';
import { Type } from 'class-transformer';

@ObjectType()
export class PipelineTaskEvent {
  @Field()
  taskId: string;
  @Field()
  pipelineId: string;
  @Field()
  projectId: string;
  @Field(() => PipelineUnits, { nullable: true })
  unit: PipelineUnits | null;
  @Field()
  @Type(() => Date)
  emittedAt: Date;
  @Field()
  message: string;
  @Field()
  messageType: 'stdout' | 'stderr' | 'stdin';
  @Field(() => TaskStatuses)
  status: TaskStatuses;
}
