import { Field, InputType, Int, ObjectType } from '@nestjs/graphql';
import { Type } from 'class-transformer';
import { IsInstance, isInstance, ValidateNested } from 'class-validator';
import { WorkUnit } from './work-unit.model';

@InputType('WorkUnitMetadataInput')
@ObjectType()
export class WorkUnitMetadata {
  @Field(() => Int)
  version = 1;

  @Type(() => WorkUnit)
  @IsInstance(WorkUnit, { each: true })
  @ValidateNested({ each: true })
  units: WorkUnit[];
}
