import { Field, InputType, ObjectType } from '@nestjs/graphql';
import { IsNotEmpty } from 'class-validator';
import {
  PipelineUnits,
  PipelineUnits as PipelineUnitTypes,
} from '../enums/pipeline-units.enum';

@ObjectType()
@InputType('WorkUnitInput')
export class WorkUnit {
  @Field(() => PipelineUnits)
  type: PipelineUnitTypes;

  @IsNotEmpty({ each: true })
  scripts: string[];
}
