import { Column, Entity } from 'typeorm';
import { AppBaseEntity } from './../commons/entities/app-base-entity';
import { SourceService } from './enums/source-service.enum';

@Entity()
export class WebhookLog extends AppBaseEntity {
  @Column()
  sourceDelivery: string;
  @Column({ type: 'enum', enum: SourceService })
  sourceService: SourceService;
  @Column()
  sourceEvent: string;
  @Column({ type: 'jsonb' })
  payload: any;
  @Column()
  localEvent: string;
  @Column({ type: 'jsonb' })
  localPayload: any;
}
